listofpackages <- c("plm", "foreign", "lmtest", "aod", "systemfit", "dygraphs","dplyr", "car", "sandwich","stats", "forecast")
#debug(utils:::unpackPkgZip)
for (j in listofpackages){
  if(sum(installed.packages()[, 1] == j) == 0) {
    install.packages(j,dependencies = TRUE)
    
  }
  library(j, character.only = T)
}

dataie <- read.table("data01.csv", stringsAsFactors = F, header = T, sep = ",")
dataff <- read.table("ffdata.csv", stringsAsFactors = F, header = T, sep = ",")

tt <- 1956
tT <- 2000

ret15 <- ts(subset(dataff, select = PR15, date >= tt & date < tT), start = c(1956, 1), frequency = 12)
retmkt <- ts(subset(dataff, select = exret_mkt, date >= tt & date < tT), start = c(1956, 1), frequency = 12)
plot(ret15)
plot(ret15, x = retmkt, col = 'blue', type = "p", 
     ylab = "PR15", xlab = "MKT")
#abline(reg = lm(ret15 ~ retmkt), col  = "red")
summary(lm(ret15 ~  1))
summary(lm(retmkt ~  1))


monthplot(ret15, col = "black", main = "Seasonality in the portfolio return")
monthplot(retmkt, main = "Seasonality in the market return")

Jan <- seasonaldummy(ret15)[, 1]

summary(lm(ret15 ~ Jan + 1)) # here we include the seasonal dummy for january
summary(lm(retmkt ~ Jan + 1))
capm <- lm(ret15 ~ retmkt+1)
summary(capm)
seasreg <- lm(ret15 ~ retmkt + Jan )
summary(seasreg)
wald.test(vcov(seasreg), coef(seasreg), H0 = c(0, 0), df = 525, 
          L = matrix(c(1, 0, 0, 
                       0, 0, 1), ncol = 3), verbose = T)

# 1962:1 2014:6
returns <- as.matrix(subset(dataff, select = PR11:PR55, date >= 1962 & date <=2014 + 5/12 + 0.01))
rf <- as.matrix(subset(dataff, select = RF, date >= 1962 & date <=2014 + 5/12 + 0.01))
ex_returns <- returns - rep(rf, ncol(returns))
factors <- as.matrix(subset(dataff, select = exret_mkt, date >= 1962 & date <=2014 + 5/12 + 0.01))


X <- cbind(matrix(1, nrow(ex_returns), 1), factors)
Y <- ex_returns
beta <- solve(t(X) %*% X) %*% t(X) %*% Y # same as lm(returns ~ factors)
 
mean_exret <- apply(X = ex_returns, 2, mean)
beta1=beta[2,]
df1=data.frame(mean_exret,beta1)
plot(df1$beta1,df1$mean_exret, main="Security Market line", xlab="betas",ylab="mean exc ret")
abline(reg = lm(df1$mean_exret ~ df1$beta1), col  = "red")

Y2 <- apply(X = Y, MARGIN = 2, mean)
X2 <- cbind(matrix(1, ncol(beta), 1), beta[2, ])
gamma <- solve(t(X2) %*% X2) %*% t(X2) %*% Y2
resid2 <- (Y2 - X2 %*% gamma)^2
TT <- nrow(X2)
k <- length(gamma)
gamma_vcov <- solve(t(X2) %*% X2) %*% t(X2) %*% diag(TT/(TT-k)*c(resid2)) %*% X2 %*% solve(t(X2) %*% X2) # the White heteroskedasticity-robust SE estimate with degree of freedom correction

gamma
gamma_vcov
gamma / sqrt(diag(gamma_vcov))


wald.test(gamma_vcov, gamma, L = matrix(c(1, 0, 0, 1), 2, 2, byrow = T), H0 = c(0, 0))
wald.test(gamma_vcov, gamma, L = diag(2), H0 = c(0, 0.0049))

#lm1 <- lm(Y2 ~ X2[, -1])
#var1 <-vcovHAC(lm1, adjust = T) # HAC errors
